<template>
  <!-- row in row -->
  <Loading v-if="$fetchState.pending && !$fetchState.error"></Loading>
  <Error v-else-if="$fetchState.error" :error="$fetchState.error"></Error>
  <div v-else class="row">
    <b-col v-if="!dataLoaded" md="3" class="pr-3"></b-col>
    <b-col v-else md="3" class="pr-3">
      <div class="nav-project-board">
        <div
          class="mb-3"
          data-intro="The list of users belonging to this project is available here"
        >
          <div class="ml-2">
            <div class="avatar-list avatar-list-stacked">
              <template v-for="user in displayedUsers">
                <Avatar
                  v-if="user.image"
                  :key="user.index"
                  v-b-tooltip.hover.right="{ variant: 'dark' }"
                  :title="user.firstName"
                  :img="user.image"
                />
                <Avatar
                  v-else
                  :key="user.index"
                  v-b-tooltip.hover.right="{ variant: 'dark' }"
                  :title="user.firstName"
                >
                  {{ user | userInitials }}
                </Avatar>
              </template>
              <!-- <Avatar
                v-b-tooltip.hover.bottom="{ variant: 'dark' }"
                data-intro="You can invite more users by clicking the plus circle"
                cursor="pointer"
                title="Invite more users"
              >
                <PlusIcon />
              </Avatar> -->
            </div>
          </div>
          <div class="form-check-description user-results-stats small mt-0">
            Showing
            <span class="search-stat-count">1</span>
            -
            <span class="search-end-count">{{ displayedUsers.length }}</span>
            of
            <span class="search-total-count">{{ allUsers.length }}</span>
            users
          </div>
        </div>
        <div class="d-none d-sm-inline-block">
          <div class="subheader mb-2">
            Description
            <div class="form-label-description">
              <span class="form-label-description-current-length">
                {{ project.short_description.length }}
              </span>
              /
              <span class="form-label-description-maxlength">200</span>
            </div>
          </div>
          <div class="mb-3">
            <textarea
              class="form-control textarea-project-description"
              data-intro="Do not forget to add a short description to your project"
              data-cy="input-description-edit-project"
              rows="4"
              :maxlength="maxDescriptionLength"
              :value="project.short_description"
              @keyup="updateProjectDescription"
              @focusout="saveProject"
              @keyup.enter="saveProject"
            ></textarea>
          </div>
          <div class="subheader mb-2">Import scenarios</div>
          <div class="mb-3">
            <div
              class="nav-project-board-form nav-project-board-scenarios-form"
              data-intro="Then, find and select a scenario"
            >
              <RimowSelectize
                data-cy="import-scenario-selectize"
                placeholder="Search in scenarios..."
                item-icon="route"
                :options="importableScenarios"
                :selected="selectedScenario"
                @change="selectedScenarioChange"
              >
                <template #button-append>
                  <a
                    data-cy="add-scenario-button"
                    class="link-secondary"
                    href="#"
                    data-intro="Once a scenario selected, use this button to add it to your board"
                    :class="{ disabled: selectedScenario ? false : true }"
                    @click="importScenario"
                  >
                    <PlusIcon class="icon-xxs" />
                  </a>
                </template>
              </RimowSelectize>
            </div>
          </div>
          <div class="subheader mb-2">Import datasets</div>
          <div data-intro="You need also to add a dataset" class="mb-3">
            <RimowSelectize
              data-cy="import-dataset-selectize"
              placeholder="Search in datasets..."
              item-icon="database"
              :options="importableDatasets"
              :selected="selectedDataset"
              @change="selectedDatasetChange"
            >
              <template #button-append>
                <a
                  data-cy="add-dataset-button"
                  class="link-secondary"
                  data-intro="Once a dataset selected, use this button to add it to your board"
                  href="#"
                  :class="{ disabled: selectedDataset ? false : true }"
                  @click="importDataset"
                >
                  <PlusIcon class="icon-xxs" />
                </a>
              </template>
            </RimowSelectize>
          </div>
          <div class="subheader mt-3 mb-2">Options</div>
          <div class="row g-2 align-items-center mb-3">
            <div class="col">
              <a href="#" class="btn w-100 disabled">
                <ArchiveIcon class="text-blue" />
                Archive
              </a>
            </div>
            <div class="col">
              <DeleteProject :id="id">
                <template #deleteAction="{ confirmDelete }">
                  <a
                    href="#"
                    class="btn w-100"
                    :class="{
                      disabled: project.state.slug === 'running',
                    }"
                    @click="confirmDelete"
                  >
                    <TrashIcon class="text-red" @click="confirmDelete" />
                    Delete
                  </a>
                </template>
              </DeleteProject>
            </div>
          </div>
        </div>
      </div>
    </b-col>
    <!-- placeholder board -->
    <b-col v-if="!dataLoaded" sm="12" md="9">
      <div class="rimow-card-deck row row-deck">
        <div
          v-for="n in 2"
          :key="n"
          class="rimow-card card-sce col-sm-6 col-lg-4 mb-2"
        >
          <ProjectScenarioCard :skeleton="true" />
        </div>
      </div>
    </b-col>
    <!-- /placeholder board -->
    <b-col v-else sm="12" md="9">
      <div class="tab-content h-100">
        <div
          class="tab-pane-board-projects tab-pane h-100 active"
          :class="importingClass"
        >
          <div
            v-if="scenarios.length || datasets.length"
            class="rimow-card-deck row row-deck"
          >
            <div
              v-for="scenario in scenarios"
              :key="scenario.id"
              class="rimow-card card-sce col-sm-6 col-lg-4 mb-2"
            >
              <ProjectScenarioCard
                :scenario="scenario"
                :scenario-running="runningScenario.id === scenario.id"
              />
            </div>
            <div
              v-for="dataset in datasets"
              :key="dataset.index"
              class="rimow-card card-sce col-sm-6 col-lg-4 mb-2"
            >
              <ProjectDatasetCard :dataset="dataset" />
            </div>
          </div>
          <EmptyData
            v-else
            title="Your project board is empty"
            description="Try importing scenarios and datasets"
            image="/illustrations/empty-project-board.svg"
            border
          >
            <template #primary-button>
              <button
                class="btn btn-primary rimow-step-by-step-guide"
                @click="showSteps()"
              >
                <HelpIcon class="icon-xs" />
                Show me how
              </button>
            </template>
          </EmptyData>
        </div>
      </div>
    </b-col>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import notificationsMixin from '~/mixins/notifications.js';
export default {
  mixins: [notificationsMixin],
  data() {
    return {
      id: this.$nuxt.$route.params.id,
      selectedScenario: undefined,
      selectedDataset: undefined,
      maxDescriptionLength: 200,
      importingClass: '',
    };
  },
  async fetch() {
    const id = this.$nuxt.$route.params.id;
    const store = this.$nuxt.context.store;
    await Promise.all([
      store.dispatch('scenarios/fetchScenarios'),
      store.dispatch('datasets/fetchDatasets'),
    ]);
    await Promise.all([
      store.dispatch('scenarios/fetchProjectScenarios', {
        projectId: id,
      }),
      store.dispatch('datasets/fetchProjectDatasets', {
        projectId: id,
      }),
    ]).catch((e) => e);
  },
  head() {
    return {
      title: 'Projects - RISIS Workspace',
    };
  },
  computed: {
    ...mapGetters({
      allScenarios: 'scenarios/allScenarios',
      allDatasets: 'datasets/allDatasets',
    }),
    dataLoaded() {
      return !!this.rootData;
    },
    rootData() {
      return this.$store.getters['projects/fullSingleProject'](this.id);
    },
    project() {
      return this.rootData.project;
    },
    datasets() {
      return this.rootData.datasets;
    },
    scenarios() {
      return this.rootData.scenarios;
    },
    displayedUsers() {
      return [this.project.author, ...this.project.members];
    },
    allUsers() {
      return [this.project.author, ...this.project.members];
    },
    importableScenarios() {
      const projectScenarioIds = this.project.scenarios.map((sc) => sc.id);
      const scenarios = this.allScenarios.filter((scenario) => {
        return !projectScenarioIds.includes(scenario.id);
      });
      const dropdownScenarios = scenarios.map((sc) => {
        return {
          id: sc.id,
          title: sc.title,
          version: sc.version,
          description: sc.description,
          tags: sc.tags,
        };
      });
      return dropdownScenarios;
    },
    importableDatasets() {
      const projectDatasetIds = this.project.datasets.map((ds) => ds.id);
      const datasets = this.allDatasets.filter((dataset) => {
        return !projectDatasetIds.includes(dataset.id);
      });
      const dropdownDatasets = datasets.map((ds) => {
        const mainVersion = Object.keys(ds.versions)[0];
        return {
          id: ds.id,
          title: ds.title,
          version: mainVersion,
          description: ds.short_description,
          tags: ds.versions[mainVersion].tags,
        };
      });
      return dropdownDatasets;
    },
    runningScenario() {
      const runningScenario = this.$store.getters[
        'projects/projectRunningScenario'
      ](this.id);
      if (runningScenario) {
        return runningScenario;
      }
      return {};
    },
  },
  beforeMount() {
    this.$store.commit('ui/setSearchWorkspaceVisible', false);
  },
  methods: {
    getInitials(user) {
      return user.username[0].toUpperCase();
    },
    selectedScenarioChange(value) {
      this.selectedScenario = value;
    },
    selectedDatasetChange(value) {
      this.selectedDataset = value;
    },
    async importScenario() {
      if (this.selectedScenario) {
        this.importingClass = 'loading';
        const response = await this.$nuxt.context.store
          .dispatch('projects/linkScenario', {
            projectId: this.id,
            scenarioId: this.selectedScenario.id,
          })
          .catch(() => {
            this.showErrorNotification('Error linking scenario');
          });
        if (response) {
          this.importingClass = '';
          this.selectedScenario = undefined;
        }
      }
    },
    async importDataset() {
      if (this.selectedDataset) {
        this.importingClass = 'loading';
        const response = await this.$nuxt.context.store
          .dispatch('projects/linkDataset', {
            projectId: this.id,
            datasetId: this.selectedDataset.id,
          })
          .catch(() => {
            this.showErrorNotification('Error linking dataset');
          });
        if (response) {
          this.importingClass = '';
          this.selectedDataset = undefined;
        }
      }
    },
    async saveProject() {
      if (this.project.changed?.length > 0) {
        if (this.project.short_description) {
          await this.$nuxt.context.store
            .dispatch('projects/saveProject', {
              id: this.id,
            })
            .then(() => {
              this.showNotification(
                'The description was updated successfully',
                'Project Updated!'
              );
              this.$nuxt.context.store.dispatch(
                'projects/unSetProjectProperty',
                {
                  projectId: this.id,
                  propertyName: 'short_description',
                }
              );
            })
            .catch(() => {
              this.showErrorNotification('Error updating project description');
            });
        } else {
          this.showErrorNotification('Description is required.');
        }
      }
    },
    updateProjectDescription(event) {
      this.$nuxt.context.store.dispatch('projects/setProjectProperty', {
        projectId: this.id,
        propertyName: 'short_description',
        value: event.target.value,
      });
    },
    showSteps() {
      this.$store.commit('ui/showIntroJs');
    },
  },
};
</script>
